#include <iostream>
#include <cmath>
#include <fstream>
#include <sstream>
#include <set>
#include <vector>
#include <map>
#include <deque>
#include <stack>
#include <algorithm>
#include <string>
#include <time.h>

using namespace std;

int main()
{
freopen("C.in", "r", stdin);
freopen("C.out", "w", stdout);
int n,color[10][7];
cin>>n;
for(int i=0;i<n;i++)
	for(int j=1;j<=6;j++)
		cin>>color[i][j];

for(int i=0;i<n;i++){
bool ok = false;
	
	if(color[i][1]==color[i][4] && color[i][4]==color[i][5]) ok = true;
	if(color[i][1]==color[i][3] && color[i][3]==color[i][5]) ok = true;
	if(color[i][1]==color[i][4] && color[i][4]==color[i][6]) ok = true;
	if(color[i][1]==color[i][3] && color[i][3]==color[i][6]) ok = true;
	if(color[i][2]==color[i][4] && color[i][4]==color[i][5]) ok = true;
	if(color[i][2]==color[i][3] && color[i][3]==color[i][5]) ok = true;
	if(color[i][2]==color[i][4] && color[i][4]==color[i][6]) ok = true;
	if(color[i][2]==color[i][3] && color[i][3]==color[i][6]) ok = true;

	if(color[i][5]==color[i][1]) ok=true;
	if(color[i][5]==color[i][2]) ok=true;
	if(color[i][5]==color[i][3]) ok=true;
	if(color[i][5]==color[i][4]) ok=true;

	if(color[i][4]==color[i][1]) ok=true;
	if(color[i][4]==color[i][2]) ok=true;
	if(color[i][4]==color[i][6]) ok=true;

	if(color[i][3]==color[i][1]) ok=true;
	if(color[i][3]==color[i][2]) ok=true;
	if(color[i][3]==color[i][6]) ok=true;

	if(color[i][2]==color[i][6]) ok=true;

	if(color[i][1]==color[i][6]) ok=true;

		if(ok) cout<<"YES"<<endl;
		else cout<<"NO"<<endl;
}
return 0;
}
